<?php 
// add the admin options page
add_action('admin_menu', 'awddropshipping_admin_add_page');
function awddropshipping_admin_add_page() {
add_options_page('Datafeedr Dropshipping', 'Datafeedr Dropshipping', 'manage_options', 'awddropshipping', 'awddropshipping_options_page');
}
// display the admin options page
function awddropshipping_options_page() {
	?>
	<div>
	<h2>Datafeedr Dropshipping Plugin</h2>
	<p>Written by <a href="http://www.affiliatewebdesigners.com/">Dave Hilditch from Affiliate Web Designers</a> with many thanks to <a href="http://www.chinawholesalectronics.com/">Ian Conza</a> for the idea in the first place and his help testing and debugging this plugin.
	<form action="options.php" method="post">
	<?php settings_fields('awddropshipping_options'); ?>
	<?php do_settings_sections('awddropshipping'); ?>
	 
	<input name="Submit" type="submit" value="<?php esc_attr_e('Save Changes'); ?>" />
	</form></div>
	 
	<?php
}

// add the admin settings and such
add_action('admin_init', 'awddropshipping_admin_init');
function awddropshipping_admin_init(){
	register_setting( 'awddropshipping_options', 'awddropshipping_options', 'awddropshipping_options_validate' );
	add_settings_section('awddropshipping_main', 'Main Settings', 'awddropshipping_section_text', 'awddropshipping');
	add_settings_field('markup', 'Site Wide Markup', 'awddropshipping_setting_markup', 'awddropshipping', 'awddropshipping_main');
//	add_settings_field('currencies', 'Accepted Currencies', 'awddropshipping_setting_listing_currencies', 'awddropshipping', 'awddropshipping_main');
	add_settings_field('countries', 'Accepted Countries', 'awddropshipping_setting_listing_countries', 'awddropshipping', 'awddropshipping_main');
	add_settings_field('paypalbutton', 'Paypal Button Code', 'awddropshipping_setting_listing_paypalbutton', 'awddropshipping', 'awddropshipping_main');
	add_settings_section('awddropshipping_instructions', 'Installation in your shop templates', 'awddropshipping_instructions_section', 'awddropshipping');
}

function awddropshipping_section_text() {
	echo '<p>Update your dropshipping settings here.</p>';
} 

function awddropshipping_instructions_section() {
	echo '<p>You need to find every location of <strong>[product.price]</strong> in <strong>ALL</strong> your Datafeedr views (product detail, related products, sales, category, search results) and replace it with: <pre>'. htmlentities ('<?php echo awd_dropshipprice($product->price); ?>') . '</pre></p>';
	echo '<p>The function above will check if drop shipping price should be applied (based on accepted countries and currencies) and display the relevant price.</p>';
	echo '<h3>Replacing the buttons</h3><p>The code below is an example from the default datafeedr templates and is how you should amend <strong>ALL</strong> sections that display a BUY button.</p>';
	echo '<pre>' . htmlentities ('
		<?php
        if (awd_isdropshippingvalid()) { ?>
          <div class="prc">[product.currency mode="sign"]<?php echo awd_dropshipprice($product->price); ?></div>
          <?php echo awd_dropshippaypalbutton($product->name, $product->price, $product->currency); }
        else { ?>
          <div class="prc">[product.currency mode="sign"][product.price]</div>
          <div class="btns">
          <a href="[product.url]" class="dfbutton dforange dflarge" title="Buy this product" target="_blank" rel="nofollow">Buy</a>
          </div>
        <?php } ?>') . '</pre>
		<p>Use the above code to replace every button section - the default button section that you should be replacing looks like this:
		<pre>'.htmlentities('          <div class="prc">[product.currency mode="sign"][product.price]</div>
          <div class="btns">
          <a href="[product.url]" class="dfbutton dforange dflarge" title="Buy this product" target="_blank" rel="nofollow">Buy</a>
          </div>') .'</pre>';
}

function awddropshipping_setting_markup() {
	$options = get_option('awddropshipping_options');
	echo "<input name='awddropshipping_options[markup]' size='40' type='text' value='{$options['markup']}' />";
	echo '<p>Markup can be overridden on a per-category basis by putting a markup value in the Datafeedr Factory -> Category -> Properties -> Keywords field. e.g. If you wish to have 15% markup, enter the value 1.15</p>';
}
function awddropshipping_setting_listing_currencies() {
	$options = get_option('awddropshipping_options');
	echo "<input name='awddropshipping_options[currencies]' size='40' type='text' value='{$options['currencies']}' />";
}
function awddropshipping_setting_listing_countries() {
	$options = get_option('awddropshipping_options');
	echo '<p>Comma separated list of countries for which drop-shipping should be applied (ISO 2-digit country codes).</p>';
	echo "<input name='awddropshipping_options[countries]' size='40' type='text' value='{$options['countries']}' />";
}
function awddropshipping_setting_listing_paypalbutton() {
	$options = get_option('awddropshipping_options');
	echo '<p>Paste your Paypal generated button code in the box below.</p>';
	echo '<p><ol><li>Replace the item_name value attribute with {productname}</li>
	<li>Replace the amount value attribute with {productprice}</li>
	<li>Replace the currency_code value attribute with {productcurrency}</li></ol></p>';	
	echo "<textarea name='awddropshipping_options[paypalbutton]' cols=80 rows=10 style='width:100%'>{$options['paypalbutton']}</textarea>";
}

// validate our options
function awddropshipping_options_validate($input) {
	$options = get_option('awddropshipping_options');
	$options['markup'] = trim($input['markup']);
	$options['currencies'] = trim($input['currencies']);
	$options['countries'] = trim($input['countries']);
	$options['paypalbutton'] = trim($input['paypalbutton']);

	/*	if(!preg_match('/^[a-z0-9]{32}$/i', $options['text_string'])) {
		$options['text_string'] = '';
	}
*/
	return $options;
}

?>
